// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlStateMachine")]
    pub struct StateMachine(Object<ffi::DzlStateMachine, ffi::DzlStateMachineClass>) @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_state_machine_get_type(),
    }
}

impl StateMachine {
    pub const NONE: Option<&'static StateMachine> = None;

    #[doc(alias = "dzl_state_machine_new")]
    pub fn new() -> StateMachine {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_state_machine_new()) }
    }

    //#[doc(alias = "dzl_state_machine_buildable_iface_init")]
    //pub fn buildable_iface_init(iface: /*Ignored*/&mut gtk::BuildableIface) {
    //    unsafe { TODO: call ffi:dzl_state_machine_buildable_iface_init() }
    //}
}

impl Default for StateMachine {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::StateMachine>> Sealed for T {}
}

pub trait StateMachineExt: IsA<StateMachine> + sealed::Sealed + 'static {
    //#[doc(alias = "dzl_state_machine_add_binding")]
    //fn add_binding(&self, state: &str, source_object: /*Unimplemented*/Option<Basic: Pointer>, source_property: &str, target_object: /*Unimplemented*/Option<Basic: Pointer>, target_property: &str, flags: glib::BindingFlags) {
    //    unsafe { TODO: call ffi:dzl_state_machine_add_binding() }
    //}

    //#[doc(alias = "dzl_state_machine_add_property")]
    //fn add_property(&self, state: &str, object: /*Unimplemented*/Option<Basic: Pointer>, property: &str, : /*Unknown conversion*//*Unimplemented*/Basic: VarArgs) {
    //    unsafe { TODO: call ffi:dzl_state_machine_add_property() }
    //}

    //#[doc(alias = "dzl_state_machine_add_property_valist")]
    //fn add_property_valist(&self, state: &str, object: /*Unimplemented*/Option<Basic: Pointer>, property: &str, var_args: /*Unknown conversion*//*Unimplemented*/Unsupported) {
    //    unsafe { TODO: call ffi:dzl_state_machine_add_property_valist() }
    //}

    //#[doc(alias = "dzl_state_machine_add_propertyv")]
    //fn add_propertyv(&self, state: &str, object: /*Unimplemented*/Option<Basic: Pointer>, property: &str, value: &glib::Value) {
    //    unsafe { TODO: call ffi:dzl_state_machine_add_propertyv() }
    //}

    #[doc(alias = "dzl_state_machine_add_style")]
    fn add_style(&self, state: &str, widget: &impl IsA<gtk::Widget>, style: &str) {
        unsafe {
            ffi::dzl_state_machine_add_style(
                self.as_ref().to_glib_none().0,
                state.to_glib_none().0,
                widget.as_ref().to_glib_none().0,
                style.to_glib_none().0,
            );
        }
    }

    //#[doc(alias = "dzl_state_machine_connect_object")]
    //fn connect_object<P: Fn() + 'static>(&self, state: &str, source: /*Unimplemented*/Option<Basic: Pointer>, detailed_signal: &str, callback: P, user_data: /*Unimplemented*/Option<Basic: Pointer>, flags: glib::ConnectFlags) {
    //    unsafe { TODO: call ffi:dzl_state_machine_connect_object() }
    //}

    #[doc(alias = "dzl_state_machine_create_action")]
    fn create_action(&self, name: &str) -> Option<gio::Action> {
        unsafe {
            from_glib_full(ffi::dzl_state_machine_create_action(
                self.as_ref().to_glib_none().0,
                name.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_state_machine_get_state")]
    #[doc(alias = "get_state")]
    fn state(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_state_machine_get_state(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_28")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_28")))]
    #[doc(alias = "dzl_state_machine_is_state")]
    fn is_state(&self, state: Option<&str>) -> bool {
        unsafe {
            from_glib(ffi::dzl_state_machine_is_state(
                self.as_ref().to_glib_none().0,
                state.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_state_machine_set_state")]
    fn set_state(&self, state: &str) {
        unsafe {
            ffi::dzl_state_machine_set_state(
                self.as_ref().to_glib_none().0,
                state.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "state")]
    fn connect_state_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_state_trampoline<P: IsA<StateMachine>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlStateMachine,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(StateMachine::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::state\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_state_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<StateMachine>> StateMachineExt for O {}

impl fmt::Display for StateMachine {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("StateMachine")
    }
}
